// JavaScript to load the Ace Editor in for the format setting

(function ($) {

	Drupal.behaviors.ace_editor = {

		attach: function(context, settings){

			$('.AceEditorTextarea', context).once('ace_editor').each(function(){

				if($('.AceEditorTextarea').length ){

					// hide textarea and add div for ace editor
					$('.AceEditorTextarea').after("<div class='EditorWrapper'><div id='AceEditor'></div></div>");			

					// css
					$('head').append('<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">');
					$('#AceEditor').css({"height": "100%", "width": '100%'});
					$('.AceEditorTextarea').css('display', 'none');
					$('.EditorWrapper').css({'position': 'relative', 'height': '350px'});
					$('#AceEditor').after('<span class="fa fa-window-maximize ButtonSize"></span>');
					$('.ButtonSize').css({'position': 'absolute', 'z-index': '10', 'top': '1em', 'right': '1em', 'color': '#fff', 'font-size': '18px'});

					// add cdn for ace editor
					$.getScript('https://cdnjs.cloudflare.com/ajax/libs/ace/1.2.6/ace.js', function() {

					    // Ace Editor settings
					    var editor = ace.edit("AceEditor");
				        editor.setTheme("ace/theme/monokai");
				        editor.getSession().setMode("ace/mode/twig");
				        editor.session.setUseWrapMode(true);
				        editor.setShowPrintMargin(false);

				        editor.getSession().setValue($('.AceEditorTextarea').val(), -1);
				        editor.getSession().on('change', function(){
				        	$(".AceEditorTextarea").val(editor.getSession().getValue());
				        });

					});

					$('.ButtonSize').click(function(){

						if($('.EditorWrapper.Open').length < 1){
							$(this).removeClass('fa-window-maximize').addClass('fa fa-window-restore');
							$('.EditorWrapper').addClass('Open');
							$('.EditorWrapper').css({'position': 'fixed', 'top': '0', 'bottom': '0', 'left': '0', 'right': '0', 'z-index': '1000', 'height': '100vh'});
						}else{
							$(this).removeClass('fa fa-window-restore').addClass('fa-window-maximize');
							$('.EditorWrapper').removeClass('Open');
							$('.EditorWrapper').css({'position': 'relative', 'height': '350px', 'z-index': '0'});
						}

					});

					$('.ButtonSize').hover(function(){

						$(this).css('color', '#d11414');

					},function(){

						$(this).css('color', '#fff');

					});

				}

			})

		}

	}

})(jQuery);